﻿<?php

/***********************************************************************************************

Tämä on esimerkki matkahuollon osoitekorttihaun rajapinnan käytöstä.
Luokka sisältää perustoiminnot xml-viestien lähettämiseen ja vastaanottoon sekä
PDF-tiedoston generointiin. Kaikki muut mahdolliset lähetysviestiin liitettävät arvot 
(katso dokumentaatio) ovat mukana, paitsi useamman paketin käsittely sekä arvojen loogisuus-
tarkistukset.

Esimerkki käyttää viestin lähetykseen/vastaanottoon cURL moduulia joka on käytössä 
PHP:n versiossa 4.0.2. ja uudemmissa.
 
************************************************************************************************/



  
/* Luodaan matkahuolto luokka ja asetetaan arvot. Esimerkissä vain pakolliset kentät */

$mh = new Matkahuolto();
 
$mh->pUserId("09430023");
$mh->Password("456");
$mh->Version("1.0");
$mh->MessageType("N");
$mh->Weight("3.25");
$mh->Packages("2");
$mh->SenderId("09430023");
$mh->ReceiverName1("Eetun lafka");
$mh->ReceiverPostal("00520");
$mh->ReceiverCity("HELSINKI");
$mh->ProductCode("30");


/* lähetetään xml-sanoma. Arvona vastaanottava palvelinosoite */

$mh->sendXML('https://mhhkiweb1.matkahuolto.fi/scripts101c/mhshipmentxmltesti.wsc/ovtinxml');

/* jos ei virheitä luodaan pdf-tiedosto */

if ($mh->ErrorNbr == "")
{
    $mh->showPDF($mh->ShipmentPdf);
}


/* Matkahuolto luokka ***********************************************************************/

class Matkahuolto
{
    function __construct()
    {
    
    /* Asetetaan alkuarvoiksi tyhjä merkkijono */
    
    $a = array('pUserId','Password','Version','Shipment','MessageType','ShipmentNumber','ShipmentDate','Weight','Volume','Packages','SenderId','SenderName1','SenderName2','SenderAddress','SenderPostal','SenderCity','SenderContactName','SenderContactNumber','SenderEmail','SenderReference','DeparturePlaceCode','DeparturePlaceName','ReceiverId','ReceiverName1','ReceiverName2','ReceiverAddress','ReceiverPostal','ReceiverCity','ReceiverContactName','ReceiverContactNumber','ReceiverEmail','ReceiverReference','DestinationPlaceCode','DestinationPlaceName','PayerCode','Remarks','ProductCode','ProductName','Pickup','PickupPayer','PickupRemarks','Delivery','DeliveryPayer','DeliveryRemarks','CODSum','CODCurrency','CODAccount','CODReference','VAKCode','VAKDescription','DocumentType','ShipmentRow','PackageId','Goods','PdfName','ShipmentPdf','ErrorNbr','ErrorMsg');
    for ($i=0; $i<=57; $i++)
        $this->$a[$i] = "";    
    }
    
     /* Lähetyssanoman arvot */
        
    function pUserId($x){$this->pUserId = $x;}
    function Password($x){$this->Password = $x;}  
    function Version($x){$this->Version = $x;}  
    function MessageType($x){$this->MessageType = $x;}  
    function ShipmentNumber($x){$this->ShipmentNumber = $x;}  
    function ShipmentDate($x){$this->ShipmentDate = $x;}    
    function Weight($x){$this->Weight = $x;} 
    function Volume($x){$this->Volume = $x;} 
    function Packages($x){$this->Packages = $x;} 
    function SenderId($x){$this->SenderId = $x;} 
    function SenderName1($x){$this->SenderName1 = $x;} 
    function SenderName2($x){$this->SenderName2 = $x;} 
    function SenderAddress($x){$this->SenderAddress = $x;} 
    function SenderPostal($x){$this->SenderPostal = $x;} 
    function SenderCity($x){$this->SenderCity = $x;} 
    function SenderContactName($x){$this->SenderContactName = $x;} 
    function SenderEmail($x){$this->SenderEmail = $x;} 
    function SenderReference($x){$this->SenderReference = $x;} 
    function DeparturePlaceCode($x){$this->DeparturePlaceCode = $x;} 
    function DeparturePlaceName($x){$this->DeparturePlaceName = $x;} 
    function ReceiverName1($x){$this->ReceiverName1 = $x;} 
    function ReceiverName2($x){$this->ReceiverName2 = $x;} 
    function ReceiverAddress($x){$this->ReceiverAddress = $x;} 
    function ReceiverPostal($x){$this->ReceiverPostal = $x;} 
    function ReceiverCity($x){$this->ReceiverCity = $x;} 
    function ReceiverContactName($x){$this->ReceiverContactName = $x;} 
    function ReceiverContactNumber($x){$this->ReceiverContactNumber = $x;} 
    function ReceiverEmail($x){$this->ReceiverEmail = $x;} 
    function ReceiverReference($x){$this->ReceiverReference = $x;} 
    function DestinationPlaceCode($x){$this->DestinationPlaceCode = $x;} 
    function DestinationPlaceName($x){$this->DestinationPlaceName = $x;} 
    function PayerCode($x){$this->PayerCode = $x;} 
    function Remarks($x){$this->Remarks = $x;} 
    function ProductCode($x){$this->ProductCode = $x;} 
    function ProductName($x){$this->ProductName = $x;} 
    function Pickup($x){$this->Pickup = $x;} 
    function PickupPayer($x){$this->PickupPayer = $x;} 
    function PickupRemarks($x){$this->PickupRemarks = $x;} 
    function Delivery($x){$this->Delivery = $x;} 
    function DeliveryPayer($x){$this->DeliveryPayer = $x;} 
    function DeliveryRemarks($x){$this->DeliveryRemarks = $x;} 
    function CODSum($x){$this->CODSum = $x;} 
    function CODCurrency($x){$this->CODCurrency = $x;} 
    function CODAccount($x){$this->CODAccount = $x;} 
    function CODReference($x){$this->CODReference = $x;} 
    function Goods($x){$this->Goods = $x;} 
    function VAKCode($x){$this->VAKCode = $x;} 
    function VAKDescription($x){$this->VAKDescription = $x;} 
    function DocumentType($x){$this->DocumentType = $x;} 
        
    /* Onnistunut paluuviestin  arvot */    
        
    function PdfName($x){$this->PdfName = $x;} 
    function ShipmentPdf($x){$this->ShipmentPdf = $x;} 
    
     /* Virheviestin arvot */
    
    function ErrorNbr($x){$this->ErrorNbr = $x;} 
    function ErrorMsg($x){$this->ErrorMsg = $x;} 
        
    public function sendXML($url)
    {
    /* Luodaan lähetettävä XML-Dokumentti. */
    
    $xml = new XMLWriter();
    $xml->openMemory(); 
    $xml->startDocument('1.0'); 
    $xml->startElement('MHShipmentRequest');
   
    $xml->writeElement('pUserId', $this->pUserId);
    $xml->writeElement('Password', $this->Password);
    $xml->writeElement('Version', $this->Version); 
     
        $xml->startElement('Shipment');
     
            $xml->writeElement('MessageType', $this->MessageType);
            $xml->writeElement('ShipmentNumber', $this->ShipmentNumber);
            $xml->writeElement('ShipmentDate', $this->ShipmentDate);
            $xml->writeElement('Weight', $this->Weight);
            $xml->writeElement('Volume', $this->Volume);
            $xml->writeElement('Packages', $this->Packages);
            $xml->writeElement('SenderId', $this->SenderId);
            $xml->writeElement('SenderName1', $this->SenderName1);
            $xml->writeElement('SenderName2', $this->SenderName2);
            $xml->writeElement('SenderAddress', $this->SenderAddress);
            $xml->writeElement('SenderPostal', $this->SenderPostal);
            $xml->writeElement('SenderCity', $this->SenderCity);
            $xml->writeElement('SenderContactName', $this->SenderContactName);
            $xml->writeElement('SenderContactNumber', $this->SenderContactNumber);
            $xml->writeElement('SenderEmail', $this->SenderEmail);
            $xml->writeElement('SenderReference', $this->SenderReference);
            $xml->writeElement('DeparturePlaceCode', $this->DeparturePlaceCode);
            $xml->writeElement('DeparturePlaceName', $this->DeparturePlaceName);
            $xml->writeElement('ReceiverId', $this->ReceiverId);
            $xml->writeElement('ReceiverName1', $this->ReceiverName1);
            $xml->writeElement('ReceiverName2', $this->ReceiverName2);
            $xml->writeElement('ReceiverAddress', $this->ReceiverAddress);
            $xml->writeElement('ReceiverPostal', $this->ReceiverPostal);
            $xml->writeElement('ReceiverCity', $this->ReceiverCity);
            $xml->writeElement('ReceiverContactName', $this->ReceiverContactName);
            $xml->writeElement('ReceiverContactNumber', $this->ReceiverContactNumber);
            $xml->writeElement('ReceiverEmail', $this->ReceiverEmail);
            $xml->writeElement('ReceiverReference', $this->ReceiverReference);
            $xml->writeElement('DestinationPlaceCode', $this->DestinationPlaceCode);
            $xml->writeElement('DestinationPlaceName', $this->DestinationPlaceName);
            $xml->writeElement('PayerCode', $this->PayerCode);
            $xml->writeElement('Remarks', $this->Remarks);
            $xml->writeElement('ProductCode', $this->ProductCode);
            $xml->writeElement('ProductName', $this->ProductName);
            $xml->writeElement('Pickup', $this->Pickup);
            $xml->writeElement('PickupPayer', $this->PickupPayer);
            $xml->writeElement('PickupRemarks', $this->PickupRemarks);
            $xml->writeElement('Delivery', $this->Delivery);
            $xml->writeElement('DeliveryPayer', $this->DeliveryPayer);
            $xml->writeElement('DeliveryRemarks', $this->DeliveryRemarks);
            $xml->writeElement('CODSum', $this->CODSum);
            $xml->writeElement('CODCurrency', $this->CODCurrency);
            $xml->writeElement('CODAccount', $this->CODAccount);
            $xml->writeElement('CODReference', $this->CODReference);
            $xml->writeElement('Goods', $this->Goods);
            $xml->writeElement('VAKCode', $this->VAKCode);
            $xml->writeElement('VAKDescription', $this->VAKDescription);
            $xml->writeElement('DocumentType', $this->DocumentType);
        
        $xml->endElement();
  
    $xml->endElement();
    define('sendXml', $xml->flush());
    $xml->endDocument();    

     /* Lähetetään XML */

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL,$url); 
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1); 
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);
    curl_setopt($ch, CURLOPT_TIMEOUT, 1000); 
    curl_setopt($ch, CURLOPT_POSTFIELDS, sendXml); 
    curl_setopt($ch, CURLOPT_POST, 1);  
    curl_setopt($ch, CURLOPT_HTTPHEADER,array('Content-Type: text/xml')); 

    $res = curl_exec($ch);
    
    /* Vastaanotetaan paluuviesti */
    
    if(curl_error($ch)==null){
     
        $reader = new XMLReader();
        $reader->XML($res);
        
         while ($reader->read()) {
   
            if($reader->nodeType == 1)
            {
                 /* Asetetaan paluuviestin arvot */
                 
                switch ($reader->name)
                {
                 case "ShipmentNumber":
                    $reader->read();
                    $this->ShipmentNumber($reader->value);
                    break;
                 case "SenderReference":
                    $reader->read();
                    $this->SenderReference($reader->value);
                    break;    
                 case "ShipmentPdf":
                    $reader->read();
                    $this->ShipmentPdf($reader->value);
                    break;    
                 case "PdfName":
                    $reader->read();
                    $this->PdfName($reader->value);
                    break; 
                 case "ErrorNbr":
                    $reader->read();
                    $this->ErrorNbr($reader->value);
                    break;   
                 case "ErrorMsg":
                    $reader->read();
                    $this->ErrorMsg($reader->value);
                    break;      
                }
            }
         }
       }
    }
    
    public function showPDF($pdf){
        
         /* Luodaan PDF-tiedosto */
        
        $filebytes = base64_decode($pdf);
        header("Content-type:application/pdf");
        header("Content-Disposition:attachment;filename='$this->ShipmentNumber.pdf'");
        echo $filebytes;

    
    }
    
}
 


?>
